curl --request PATCH \
--url https://api.withampersand.com/v1/projects/{projectIdOrName}/provider-apps/{providerAppId} \
--header 'Content-Type: application/json' \
--header 'X-Api-Key: <api-key>' \
--data '
{
"updateMask": [
"externalRef",
"clientId"
],
"providerApp": {
"externalRef": "external-id-123",
"provider": "salesforce",
"clientId": "client-id-123",
"clientSecret": "client-secret-123",
"scopes": [
[
"read",
"write"
]
],
"metadata": {
"authQueryParams": {
"optional_scope": [
"automation.sequences.read"
]
},
"providerParams": {
"packageInstallURL": "https://login.salesforce.com/packaging/installPackage.apexp?p0=04t123456789",
"gcpProjectId": "my-gcp-project",
"gcpPubSubTopicName": "my-topic"
}
}
}
}
'import requests
url = "https://api.withampersand.com/v1/projects/{projectIdOrName}/provider-apps/{providerAppId}"
payload = {
"updateMask": ["externalRef", "clientId"],
"providerApp": {
"externalRef": "external-id-123",
"provider": "salesforce",
"clientId": "client-id-123",
"clientSecret": "client-secret-123",
"scopes": [["read", "write"]],
"metadata": {
"authQueryParams": { "optional_scope": ["automation.sequences.read"] },
"providerParams": {
"packageInstallURL": "https://login.salesforce.com/packaging/installPackage.apexp?p0=04t123456789",
"gcpProjectId": "my-gcp-project",
"gcpPubSubTopicName": "my-topic"
}
}
}
}
headers = {
"X-Api-Key": "<api-key>",
"Content-Type": "application/json"
}
response = requests.patch(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'PATCH',
headers: {'X-Api-Key': '<api-key>', 'Content-Type': 'application/json'},
body: JSON.stringify({
updateMask: ['externalRef', 'clientId'],
providerApp: {
externalRef: 'external-id-123',
provider: 'salesforce',
clientId: 'client-id-123',
clientSecret: 'client-secret-123',
scopes: [['read', 'write']],
metadata: {
authQueryParams: {optional_scope: ['automation.sequences.read']},
providerParams: {
packageInstallURL: 'https://login.salesforce.com/packaging/installPackage.apexp?p0=04t123456789',
gcpProjectId: 'my-gcp-project',
gcpPubSubTopicName: 'my-topic'
}
}
}
})
};
fetch('https://api.withampersand.com/v1/projects/{projectIdOrName}/provider-apps/{providerAppId}', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));
{
"id": "provider-app-123",
"projectId": "project-456",
"provider": "salesforce",
"clientId": "client-id-123",
"createTime": "2023-11-07T05:31:56Z",
"externalRef": "external-id-123",
"scopes": [
[
"oauth",
"offline",
"crm.read"
]
],
"metadata": {
"authQueryParams": {
"optional_scope": [
"automation.sequences.read"
]
},
"providerParams": {
"packageInstallURL": "https://login.salesforce.com/packaging/installPackage.apexp?p0=04t123456789",
"gcpProjectId": "my-gcp-project",
"gcpPubSubTopicName": "my-topic"
}
},
"updateTime": "2023-11-07T05:31:56Z"
}{
"type": "about:blank",
"href": "https://www.belgif.be/specification/rest/api-guide/#standardized-problem-types",
"title": "Bad Request",
"status": 400,
"detail": "The input message is incorrect",
"instance": "123456-1234-1235-4567489798",
"issues": [
{
"type": "about:blank",
"detail": "exampleNumericProperty should be numeric",
"in": "path",
"name": "exampleNumericProperty",
"value": "abc"
},
{
"type": "about:blank",
"title": "Input isn't valid with respect to schema",
"detail": "examplePropertyWithPattern a2345678901 doesn't match pattern '^\\d{11}$'",
"in": "body",
"name": "items[0].examplePropertyWithPattern",
"value": "a2345678901"
}
]
}{
"type": "urn:problem-type:exampleOrganization:exampleProblem",
"href": "https://www.belgif.be/specification/rest/api-guide/#standardized-problem-types",
"title": "Description of the type of problem that occurred",
"status": 400,
"detail": "Description of specific occurrence of the problem",
"instance": "urn:uuid:123e4567-e89b-12d3-a456-426614174000"
}Update a provider app
Authorizations
Path Parameters
The Ampersand project ID or project name.
ID of the provider app, returned by the CreateProviderApp call.
Body
Array of field paths specifying which fields to update. Allowed values include:
- externalRef
- clientId
- clientSecret
- provider
- scopes
- metadata
["externalRef", "clientId"]The provider app fields to update. (Only include the fields you'd like to update.)
Show child attributes
Show child attributes
Response
The updated provider app
The provider app ID.
"provider-app-123"
The Ampersand project ID.
"project-456"
The SaaS provider that this app connects to.
"salesforce"
The OAuth client ID for this app.
"client-id-123"
The time the provider app was created.
The ID used by the provider to identify the app (optional).
"external-id-123"
The OAuth scopes for this app.
Provider-specific configuration that extends the standard OAuth flow.
Show child attributes
Show child attributes
The time the provider app was updated.
Was this page helpful?

